
# TODO move to root?

module Core::Game
  
  class Tile

    attr_reader :properties
    attr_accessor :x, :y, :z

    def initialize(sprite, x, y, z, props=[])
      @sprite = sprite
      @x, @y, @z = x, y, z
      if props[:collide]
        @passable = !props[:collide].to_b
      else
        @passable = true
      end
      @properties = props
    end

    def draw(x, y)
      if @x + x + 32 < 0 or @y + y + 32 < 0 or @x + x >1024 or @y + y > 768
        return
      end
      @sprite.draw(@x+x, @y+y, @z)
    end

    def passable?
      return @passable
    end

  end
  
end
