
require "base64"
require "zlib"

module Core

  def self.save_game(name="autosave")
    state = Core.window.state
    if state.class == States::GameState
      map = state.map
      party = state.party
    else
      map = Core.window.saved.map
      party = Core.window.saved.party
    end
    map_obj = map.objects
    map_misc = map.misc
    map_file = map.current.properties[:file]
    f = File.open("#{Core::SAVE_DIR}#{name}.esf", "wb")
    str = "#{state.class.to_s.split("::").last}\n"
    str += "#{map_file}\n"
    str += "#{party}"
    str += "START_MAP_OBJ\n"
    map_obj.each do |obj|
      next if obj.dead?
      str += "#{obj.to_save}\n"
    end
    str += "END_MAP_OBJ\n"
    # TODO is this actually used?
    str += "START_MAP_MISC\n"
    map_misc.each do |misc|
      str += "#{misc.class}\n"
      #str += "#{misc.to_save}\n"
    end
    str += "END_MAP_MISC\n"
    deflate = Zlib::Deflate.new(Zlib::BEST_COMPRESSION)
    # take that, script kiddies!
    comp = deflate.deflate(Base64.encode64(str), Zlib::FINISH)
    deflate.close
    f.puts(comp)
    f.close
  end

end
