
module Core::States
  
  class StartMenu < State
    
    include Core

    def initialize(window)
      super(window)
      @background = Core.sprite("menu/start_background") # FIXME use window background
      @w = Core::GUI::Window.new(0, 0, 1024, 768, Trans.menu(:titlescreen_title), false)
      @w.add(:newgame, Core::GUI::Button.new(160, 544, 256, 64, Trans.menu(:newgame), lambda { Core.window.advance(GameState.new(Core.window)); @song.stop }, false))
      #@w.add(:loadgame, Core::GUI::Button.new(608, 544, 256, 64, Trans.menu(:loadgame), lambda { Core.window.advance(LoadMenu.new(Core.window)) }, false))
      @w.add(:loadgame, Core::GUI::Button.new(608, 544, 256, 64, Trans.menu(:loadgame), lambda { Core.load_game }))
      @w.add(:options, Core::GUI::Button.new(160, 640, 256, 64, Trans.menu(:options), lambda { Core.window.advance(OptionMenu.new(Core.window)) }, false))
      @w.add(:update, Core::GUI::Button.new(608, 640, 256, 64, Trans.menu(:update), lambda { Core.window.advance(UpdateMenu.new(Core.window)) }, false))
      @leaves = Core::Particles.new(:title_leaves, 512, 0)
      @song = Core::Song.new("Greendjohn - Rebirth")
      @song.play(true)
      @w.get(:loadgame).disable if Dir.entries("#{Core::SAVE_DIR}").join == "..."
    end

    def update
      update_cursor
      @w.update
      @leaves.update
    end

    def draw
      @background.draw(0, 0, 0)
      @w.draw
      @leaves.draw
      draw_cursor
    end

  end
  
end
