
# This is kind of a database and not actually used by the game
# Usage: ruby world.rb [tag 1] ... [tag n]
# Returns all objects that have ALL of the given tags
# If no arguments are given, returns all objects

require 'rubygems'
require 'awesome_print'

module World

  class WorldObject
    attr_reader :name, :tags, :desc
    def initialize(name, tags, desc='')
      @name = name
      @tags = tags
      @desc = desc
    end
  end

  @objects = []

  def self.add(being)
    @objects.push(being)
  end

  def self.setup(beings)
    beings.each do |ary|
      add(WorldObject.new(ary[0], ary[1], ary[2]))
    end
  end

  def self.find_name(name)
    @objects.each do |being|
      return being if being.name == name
    end
  end

  def self.find_tag(tag)
    beings = []
    @objects.each do |being|
      beings.push(being) if being.tags.include?(tag)
    end
    return beings
  end

  def self.find_tags(tags)
    return @objects if tags.empty?
    beings = []
    return @objects if tags.empty?
    @objects.each do |being|
      new = tags.clone
      new.delete_if { |t| being.tags.include?(t) }
      beings.push(being) if new.empty?
    end
    return beings
  end

end

animals = [
  ['Wolf', [:animal, :wild, :forest, :plains, :mountain], 'desc'],
  ['Brown bear', [:animal, :wild, :aggressive, :forest, :mountain, :nocturnal], 'http://en.wikipedia.org/wiki/Brown_Bear'],
  ['Deer', [:animal, :wild, :plains, :forest, :mountain], 'http://en.wikipedia.org/wiki/Deer'],
  ['Rabbit', [:animal, :wild, :hunted, :small, :plains, :forest], 'desc'],
  ['Crow', [:animal, :bird, :plains, :forest, :wild], 'desc'],
  ['Lynx', [:animal, :wild, :forest, :nocturnal], 'http://en.wikipedia.org/wiki/Eurasian_Lynx'],
  ['Wild boar', [:animal, :wild, :aggressive, :forest], 'http://en.wikipedia.org/wiki/Wild_boar'],
  ['Roe deer', [:animal, :wild, :forest, :plains, :hunted], 'http://en.wikipedia.org/wiki/Roe_Deer'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
  ['name', [], 'desc'],
]

plants = [
  ['name', [], 'desc'],
]

places = [
  ['Alduro', [:village, :forest], 'desc'],
  ['Japyrol', [:city, :forest], 'desc'],
]

World.setup(animals + plants + places)
ap World.find_tags(ARGV.map(&:to_sym))
